/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Apr 6, 2005
 *
 */
package com.sunlabs.archsim.tests.merge;

import java.util.Iterator;

import com.sunlabs.archsim.gasp.Action;
import com.sunlabs.archsim.gasp.Function;
import com.sunlabs.archsim.gasp.Terminal;

/**
 * @author ib27688
 * 
 */
public class MergeTestSink extends Action {
	
	protected int index;
	
	public MergeTestSink(String name) {
		super(name);
		outputFunctions.put(MergeTestGlobal.SINK_ACK_IN,
							new ActionFired());
	} // FifoAction
	
	/** Vacuous function used to acknowldge that the action has fired */ 
	private class ActionFired extends Function {
		
		public ActionFired() {
			super("Vacous");
			functionDelay= MergeTestGlobal.SINK_DELAY;
		}
	
		public Object value() {
			Iterator ti= terminals.iterator();
			Terminal t= null;
			boolean done= false;
			while (!done && ti.hasNext()) {
				t= (Terminal)(ti.next());
				if (t.getBaseName().equals(MergeTestGlobal.SINK_IN)) {
					done= true;
				}
			}
			if (t != null && MergeTestGlobal.sinkDisplayReceived ) {
				director.journal("Sink received " + t.getData());
			}
			return null;
		} // value
	} // AcknowledgeData

}
